
Dim args, info
Set args = WScript.Arguments
If args.Count < 2 Then
	info =  "Usage: CreateDomains.vbs [password of system] [csv file name]" & Chr(13) & Chr(10)
	info = info  & " eg: CreateDomains.vbs mypass domainsex.csv"
	WScript.Echo info
	WScript.Quit
End If

Dim hRes
Dim oSvr, oDomainCollection

Set oSvr = CreateObject("EmailArchitectObjects.ServerRoot")
hRes = oSvr.Connect( "localhost", "system", Trim(args(0)), 0 )
If hRes <> 0 Then
	WScript.Echo "Connecting server failed!"
	WScript.Quit()
End If

Set oDomainCollection = oSvr.DomainCollection 

Const ForReading = 1
Dim fso, f

Dim textname, fname
textname = Trim(args(1))
If InStr( 1, textname, ":" ) <= 0 Then
	fname = WScript.ScriptFullName 'textname is not a full path, convert it.
	Dim pos
	pos = InStrRev( fname, "\" )
	fname = Mid( fname, 1, pos )
	textname = fname & textname
End If

Set fso = CreateObject("Scripting.FileSystemObject")
Set f = fso.OpenTextFile( textname, ForReading, False )

Dim s, nIndex

nIndex = 0

Do While( f.AtEndOfStream <> True )
	s = f.ReadLine()
	If nIndex > 0 Then
		Call fnTrim( s, " ," & Chr(10) & Chr(13) & Chr(9))
		If s <> "" Then
			CreateDomain oDomainCollection, s, nIndex
		End If
	End If
	nIndex = nIndex + 1
Loop

f.Close()

Sub CreateDomain( ByRef oDomains, ByRef s, ByRef nIndex )

	Dim arTemp
	arTemp = Split( s, "," )
	Dim i, nCount
	
	nCount = UBound(arTemp)
	If (nCount - LBound(arTemp)) < 3 Then
		Exit Sub
	End If	
	
	Dim oDomain
	Set oDomain = CreateObject("EmailArchitectObjects.Domain")
	
	WScript.Echo Chr(13) & Chr(10)
	WScript.Echo "***********************************************************"
	WScript.Echo nIndex & ": Processing " & s & " ..."
	WScript.Echo "***********************************************************"

	oDomain.Name = LCase(Trim(arTemp(LBound(arTemp))))
	oDomain.MaxMBXSize = CLng(Trim(arTemp(LBound(arTemp)+2)))*1024*1024 '10MB mailbox
	oDomain.IsAlias = 0 'local domain
	oDomain.Enabled = 1 'active
	oDomain.MaxUsers = CLng(Trim(arTemp(LBound(arTemp)+1)))
	oDomain.Option = Trim(arTemp(LBound(arTemp)+3))
	oDomain.Flags = 1
	
	Set oDomain = oDomains.Add( oDomain )
	If oDomain Is Nothing Then
		WScript.Echo  "This domain exists, failed to add new domain!"
	Else
		WScript.Echo "add domain:" & LCase(Trim(arTemp(LBound(arTemp)))) & " succeeded!"
	End If
End Sub
				
				
'========================================================
' fnTrim
'========================================================
Function fnTrim( Byref src, trimer )
	Dim i, nCount, ch
	nCount = Len(src)
	For i = 1 To nCount
		ch = Mid( src, i, 1 )
		If InStr( 1, trimer, ch ) < 1 Then
			Exit For
		End If
	Next
	
	src = Mid( src, i )
	nCount = Len(src)
	For i = nCount To 1 Step -1
		ch = Mid( src, i, 1 )
		If InStr( 1, trimer, ch ) < 1 Then
			Exit For
		End If	
	Next
	src = Mid( src, 1, i )
End Function					